<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/css/bootstrap.min.css" crossorigin="anonymous">
    <title>GP2 Interpreter</title>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom box-shadow p-3 px-md-4 mb-3">
        <a class="navbar-brand" href="#">GP2</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarText" aria-controls="navbarText" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarText">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="/">Interpreter</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="/source">Compiler</a>
                </li>
            </ul>
            <a class="btn btn-outline-primary" href="https://gitlab.com/YorkCS/Batman/GP2-HTTP" target="_blank">GitLab</a>
        </div>
    </nav>
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm">
                <div class="form-group">
                    <label for="gp2Program"><strong>GP2 Program</strong></label>
                    <textarea class="form-control" id="gp2Program" rows="10"></textarea>
                </div>
                <div class="form-group">
                    <label for="inputGraph"><strong>Input Graph</strong></label>
                    <textarea class="form-control" id="inputGraph" rows="7"></textarea>
                </div>
            </div>
            <div id="gp2InRender" class="col-sm" style="padding-top: 32px;"></div>
        </div>
        <div class="row">
            <div class="col-sm">
                <div class="form-group">
                    <label for="outputGraph"><strong>Output Graph</strong></label>
                    <textarea readonly class="form-control" id="outputGraph" rows="7"></textarea>
                </div>
            </div>
            <div id="gp2OutRender" class="col-sm" style="padding-top: 32px;"></div>
        </div>
    </div>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.1/umd/popper.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/js/bootstrap.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/viz.js/2.1.2/viz.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/viz.js/2.1.2/full.render.js" crossorigin="anonymous"></script>
    <script type="text/javascript">
        $(function() {
            var viz = new Viz();

            function renderError(err) {
                var es = err.split("\n");
                var result = '<p class="lead">' + es.shift() + '</p>';

                es.forEach(function(e) {
                    result += '<p>' + e + '</p>';
                });

                return result;
            }

            function performRender(graph, id) {
                $.ajax({
                    url : '/render',
                    data : JSON.stringify({graph: graph}),
                    contentType : 'application/json',
                    type : 'POST',
                })
                .done(function(response) {
                    viz.renderSVGElement(response.graph).then(function(el) {
                        el.removeAttribute('height');
                        el.removeAttribute('width');
                        el.setAttribute('style', 'object-fit: contain; width: 100%; max-height: 512px;');
                        $("#" + id).html('');
                        document.getElementById(id).appendChild(el);
                    });
                })
                .fail(function(response) {
                    try {
                        $("#" + id).html(renderError(response.responseJSON.error));
                    } catch (e) {
                        $("#" + id).html(renderError('Unable to communicate with server.'));
                    }
                });
            }

            function performInterpret(program, input) {
                $.ajax({
                    url : '/interpret',
                    data : JSON.stringify({program: program, graph: input}),
                    contentType : 'application/json',
                    type : 'POST',
                })
                .done(function(response) {
                    $("#outputGraph").val(response.graph);
                    performRender(response.graph, "gp2OutRender");
                })
                .fail(function(response) {
                    $("#outputGraph").val('');
                    try {
                        $("#gp2OutRender").html(renderError(response.responseJSON.error));
                    } catch (e) {
                        $("#gp2OutRender").html(renderError('Unable to communicate with server.'));
                    }
                });
            }

            var oldInput = "";
            $("#inputGraph").on("change keyup paste", function() {
                var input = $(this).val();
                if (input == oldInput) {
                    return;
                }

                oldInput = input;
                performRender(input, "gp2InRender");
                performInterpret($("#gp2Program").val(), input);
            });

            var oldProgram = "";
            $("#gp2Program").on("change keyup paste", function() {
                var program = $(this).val();
                if (program == oldProgram) {
                    return;
                }

                oldProgram = program;
                performInterpret(program, $("#inputGraph").val());
            });
        });
    </script>
</body>
</html>
